theory Tmp imports RPO
begin

fun gtest :: "'f \<Rightarrow> ('f,'v)term \<Rightarrow> bool"
where "gtest _ (Var _) = False"
   |  "gtest f (Fun f' ts) = ((f = f') \<or> any (gtest f) ts)"

fun gtest_HO :: "('f \<Rightarrow> ('f,'v)term \<Rightarrow> bool) \<Rightarrow> ('f \<Rightarrow> ('f,'v)term \<Rightarrow> bool)"
where "gtest_HO g _ (Var _) = False"
    | "gtest_HO g f (Fun f' ts) = ((f = f') \<or> any (g f) ts)"

(* this should have been proven somewhere already *)
lemma gtest_mono: "mono gtest_HO"
proof
  fix x y :: "('f \<Rightarrow> ('f,'v)term \<Rightarrow> bool)"
  assume xy: "x \<le> y"
  show "gtest_HO x \<le> gtest_HO y"
  proof
    fix f t
    assume "gtest_HO x f t"
    thus "gtest_HO y f t"
    proof (induct t, simp)
      case (Fun f' ts)
      show ?case        
      proof (cases "f = f'", simp)
        case False
        with Fun obtain t where t: "t \<in> set ts" and x: "x f t" by auto
        from x xy have y: "y f t" by auto
        with t show ?thesis by auto
      qed
    qed
  qed
qed
      
(* also obvious, and possibly proven somewhere *)
lemma "gtest = lfp gtest_HO"
proof(rule ext, rule ext)
  fix f t
  show "gtest f t = lfp gtest_HO f t"
  proof (induct t)
    case (Var x)
    let ?x = x    
    from cong[OF cong[OF lfp_unfold[OF gtest_mono, symmetric] HOL.refl] HOL.refl, of f "Var ?x"] have "lfp gtest_HO f (Var ?x) = gtest_HO (lfp gtest_HO) f (Var ?x)" by simp
    thus ?case by simp
  next
    case (Fun f' ts)
    from cong[OF cong[OF lfp_unfold[OF gtest_mono, symmetric] HOL.refl] HOL.refl, of f "Fun f' ts"] have id: "lfp gtest_HO f (Fun f' ts) = gtest_HO (lfp gtest_HO) f (Fun f' ts)" by simp
    show ?case
      by (simp only: id gtest_HO.simps gtest.simps, auto simp: Fun)
  qed
qed
      
    
    
    
    

thm lpo_unbounded_rel_def
thm lpo_unbounded_sumC_def
thm lpo_unbounded_graph_def


thm gtest_rel_def
thm gtest_sumC_def
thm gtest_graph_def

lemma "gtest_dom (f,t)"
proof
  fix y
  assume "gtest_rel y (f,t)"
  thus "gtest_dom y"
  proof
    thm gtest_rel_def

fun htest :: "'f \<Rightarrow> ('f,'v)term \<Rightarrow> bool"
where "htest _ (Var _) = False"
   |  "htest f (Fun f' ts) = ((f = f') \<or> any (htest f) ts)"






